OGRE: Ogre::BillboardParticleRenderer Class Reference - OGRE Documentation

# Ogre::BillboardParticleRenderer Class Reference

Specialisation of ParticleSystemRenderer to render particles using a BillboardSet. More...

`#include <OgreBillboardParticleRenderer.h>`

Inheritance diagram for Ogre::BillboardParticleRenderer:

[legend]

List of all members.

## Public Member Functions
| BillboardParticleRenderer ()
| ~BillboardParticleRenderer ()
void | setBillboardType (BillboardType bbt)
| Sets the type of billboard to render.
BillboardType | getBillboardType (void) const
| Returns the billboard type in use.
void | setUseAccurateFacing (bool acc)
  | Sets whether or not billboards should use an 'accurate' facing model based on the vector from each billboard to the camera, rather than an optimised version using just the camera direction. Remarks: By default, the axes for all billboards are calculated using the camera's view direction, not the vector from the camera position to the billboard. The former is faster, and most of the time the difference is not noticeable. However for some purposes (e.g. very large, static billboards) the changing billboard orientation when rotating the camera can be off putting, therefore you can enable this option to use a more expensive, but more accurate version. Parameters:
  | acc | True to use the slower but more accurate model. Default is false.
bool | getUseAccurateFacing (void) const
| Gets whether or not billboards use an 'accurate' facing model based on the vector from each billboard to the camera, rather than an optimised version using just the camera direction.
void | setBillboardOrigin (BillboardOrigin origin)
| Sets the point which acts as the origin point for all billboards in this set.
BillboardOrigin | getBillboardOrigin (void) const
| Gets the point which acts as the origin point for all billboards in this set.
void | setBillboardRotationType (BillboardRotationType rotationType)
| Sets billboard rotation type.
BillboardRotationType | getBillboardRotationType (void) const
| Sets billboard rotation type.
void | setCommonDirection (const Vector3 &vec)
| Use this to specify the common direction given to billboards of type BBT_ORIENTED_COMMON.
const Vector3 & | getCommonDirection (void) const
| Gets the common direction for all billboards (BBT_ORIENTED_COMMON).
void | setCommonUpVector (const Vector3 &vec)
| Use this to specify the common up-vector given to billboards of type BBT_PERPENDICULAR_SELF.
const Vector3 & | getCommonUpVector (void) const
| Gets the common up-vector for all billboards (BBT_PERPENDICULAR_SELF).
void | setPointRenderingEnabled (bool enabled)
  | Set whether or not the BillboardSet will use point rendering rather than manually generated quads. Remarks: By default a billboardset is rendered by generating geometry for a textured quad in memory, taking into account the size and orientation settings, and uploading it to the video card. The alternative is to use hardware point rendering, which means that only one position needs to be sent per billboard rather than 4 and the hardware sorts out how this is rendered based on the render state. Using point rendering is faster than generating quads manually, but is more restrictive. The following restrictions apply: Only the BBT_POINT type is supported Size and appearance of each billboard is controlled by the material (Pass::setPointSize, Pass::setPointSizeAttenuation, Pass::setPointSpritesEnabled) Per-billboard size is not supported (stems from the above) Per-billboard rotation is not supported, this can only be controlled through texture unit rotation Only BBO_CENTER origin is supported Per-billboard texture coordinates are not supported You will almost certainly want to enable in your material pass both point attenuation and point sprites if you use this option. Parameters:
  | enabled | True to enable point rendering, false otherwise
bool | isPointRenderingEnabled (void) const
| Returns whether point rendering is enabled.
const String & | getType (void) const
| Gets the type of this renderer - must be implemented by subclasses.
void | _updateRenderQueue (RenderQueue *queue, std::list< Particle * > &currentParticles, bool cullIndividually)
| Delegated to by ParticleSystem::_updateRenderQueue. Remarks: The subclass must update the render queue using whichever Renderable instance(s) it wishes.
void | visitRenderables (Renderable::Visitor *visitor, bool debugRenderables=false)
| Required method to allow the renderer to communicate the Renderables it will be using to render the system to a visitor. See also: MovableObject::visitRenderables
void | _setMaterial (MaterialPtr &mat)
| Sets the material this renderer must use; called by ParticleSystem.
void | _notifyCurrentCamera (Camera *cam)
| Delegated to by ParticleSystem::_notifyCurrentCamera.
void | _notifyParticleRotated (void)
| Optional callback notified when particles are rotated.
void | _notifyParticleResized (void)
| Optional callback notified when particles are resized individually.
void | _notifyParticleQuota (size_t quota)
| Tells the renderer that the particle quota has changed.
void | _notifyAttached (Node *parent, bool isTagPoint=false)
| Delegated to by ParticleSystem::_notifyAttached.
void | _notifyDefaultDimensions (Real width, Real height)
| Tells the renderer that the particle default size has changed.
void | setRenderQueueGroup (uint8 queueID)
| Sets which render queue group this renderer should target with it's output.
void | setKeepParticlesInLocalSpace (bool keepLocal)
| Setting carried over from ParticleSystem.
SortMode | _getSortMode (void) const
| Gets the desired particles sort mode of this renderer.
BillboardSet * | getBillboardSet (void) const
| Access BillboardSet in use.
virtual void | _notifyParticleEmitted (Particle *particle)
| Optional callback notified when particle emitted.
virtual void | _notifyParticleExpired (Particle *particle)
| Optional callback notified when particle expired.
virtual void | _notifyParticleMoved (std::list< Particle * > &currentParticles)
| Optional callback notified when particles moved.
virtual void | _notifyParticleCleared (std::list< Particle * > &currentParticles)
| Optional callback notified when particles cleared.
virtual ParticleVisualData * | _createVisualData (void)
| Create a new ParticleVisualData instance for attachment to a particle.
virtual void | _destroyVisualData (ParticleVisualData *vis)
| Destroy a ParticleVisualData instance.
ParamDictionary * | getParamDictionary (void)
| Retrieves the parameter dictionary for this class.
const ParamDictionary * | getParamDictionary (void) const
const ParameterList & | getParameters (void) const
| Retrieves a list of parameters valid for this object.
virtual bool | setParameter (const String &name, const String &value)
| Generic parameter setting method.
virtual void | setParameterList (const NameValuePairList &paramList)
| Generic multiple parameter setting method.
virtual String | getParameter (const String &name) const
| Generic parameter retrieval method.
virtual void | copyParametersTo (StringInterface *dest) const
| Method for copying this object's parameters to another object.
void * | operator new (size_t sz, const char *file, int line, const char *func)
| operator new, with debug line info
void * | operator new (size_t sz)
void * | operator new (size_t sz, void *ptr)
| placement operator new
void * | operator new[] (size_t sz, const char *file, int line, const char *func)
| array operator new, with debug line info
void * | operator new[] (size_t sz)
void | operator delete (void *ptr)
void | operator delete (void *ptr, void *)
void | operator delete (void *ptr, const char *, int, const char *)
void | operator delete[] (void *ptr)
void | operator delete[] (void *ptr, const char *, int, const char *)
## Static Public Member Functions
static void | cleanupDictionary ()
| Cleans up the static 'msDictionary' required to reset Ogre, otherwise the containers are left with invalid pointers, which will lead to a crash as soon as one of the ResourceManager implementers (e.g.
## Protected Member Functions
bool | createParamDictionary (const String &className)
| Internal method for creating a parameter dictionary for the class, if it does not already exist.
## Protected Attributes
BillboardSet * | mBillboardSet
| The billboard set that's doing the rendering.
String | mParamDictName
| Class name for this instance to be used as a lookup (must be initialised by subclasses).
## Static Protected Attributes
static CmdBillboardType | msBillboardTypeCmd
static CmdBillboardOrigin | msBillboardOriginCmd
static CmdBillboardRotationType | msBillboardRotationTypeCmd
static CmdCommonDirection | msCommonDirectionCmd
static CmdCommonUpVector | msCommonUpVectorCmd
static CmdPointRendering | msPointRenderingCmd
static CmdAccurateFacing | msAccurateFacingCmd
static ParamDictionaryMap | msDictionary
| Dictionary of parameters.
## Classes
class | CmdAccurateFacing
| Command object for accurate facing(see ParamCommand). More...
class | CmdBillboardOrigin
| Command object for billboard origin (see ParamCommand). More...
class | CmdBillboardRotationType
| Command object for billboard rotation type (see ParamCommand). More...
class | CmdBillboardType
| Command object for billboard type (see ParamCommand). More...
class | CmdCommonDirection
| Command object for common direction (see ParamCommand). More...
class | CmdCommonUpVector
| Command object for common up-vector (see ParamCommand). More...
class | CmdPointRendering
| Command object for point rendering (see ParamCommand). More...

## Detailed Description

Specialisation of ParticleSystemRenderer to render particles using a BillboardSet.

Remarks:
  This renderer has a few more options than the standard particle system, which will be passed to it automatically when the particle system itself does not understand them.

Definition at line 45 of file OgreBillboardParticleRenderer.h.

## Constructor & Destructor Documentation

Ogre::BillboardParticleRenderer::BillboardParticleRenderer | ( |  | ) |

Ogre::BillboardParticleRenderer::~BillboardParticleRenderer | ( |  | ) |

## Member Function Documentation

void Ogre::BillboardParticleRenderer::setBillboardType | ( | BillboardType | bbt | ) |

Sets the type of billboard to render.

Remarks:
  The default sort of billboard (BBT_POINT), always has both x and y axes parallel to the camera's local axes. This is fine for 'point' style billboards (e.g. flares, smoke, anything which is symmetrical about a central point) but does not look good for billboards which have an orientation (e.g. an elongated raindrop). In this case, the oriented billboards are more suitable (BBT_ORIENTED_COMMON or BBT_ORIENTED_SELF) since they retain an independant Y axis and only the X axis is generated, perpendicular to both the local Y and the camera Z.

Parameters:

  | bbt | The type of billboard to render

BillboardType Ogre::BillboardParticleRenderer::getBillboardType | ( | void |  | ) | const

Returns the billboard type in use.

void Ogre::BillboardParticleRenderer::setUseAccurateFacing | ( | bool | acc | ) |

Sets whether or not billboards should use an 'accurate' facing model based on the vector from each billboard to the camera, rather than an optimised version using just the camera direction.

Remarks:
  By default, the axes for all billboards are calculated using the camera's view direction, not the vector from the camera position to the billboard. The former is faster, and most of the time the difference is not noticeable. However for some purposes (e.g. very large, static billboards) the changing billboard orientation when rotating the camera can be off putting, therefore you can enable this option to use a more expensive, but more accurate version.

Parameters:

  | acc | True to use the slower but more accurate model. Default is false.

bool Ogre::BillboardParticleRenderer::getUseAccurateFacing | ( | void |  | ) | const

Gets whether or not billboards use an 'accurate' facing model based on the vector from each billboard to the camera, rather than an optimised version using just the camera direction.

void Ogre::BillboardParticleRenderer::setBillboardOrigin | ( | BillboardOrigin | origin | ) |

Sets the point which acts as the origin point for all billboards in this set.

Remarks:
  This setting controls the fine tuning of where a billboard appears in relation to it's position. It could be that a billboard's position represents it's center (e.g. for fireballs), it could mean the center of the bottom edge (e.g. a tree which is positioned on the ground), the top-left corner (e.g. a cursor).

  The default setting is BBO_CENTER.

Parameters:

  | origin | A member of the BillboardOrigin enum specifying the origin for all the billboards in this set.

Definition at line 135 of file OgreBillboardParticleRenderer.h.

BillboardOrigin Ogre::BillboardParticleRenderer::getBillboardOrigin | ( | void |  | ) | const

Gets the point which acts as the origin point for all billboards in this set.

Returns:
  A member of the BillboardOrigin enum specifying the origin for all the billboards in this set.

Definition at line 141 of file OgreBillboardParticleRenderer.h.

void Ogre::BillboardParticleRenderer::setBillboardRotationType | ( | BillboardRotationType | rotationType | ) |

Sets billboard rotation type.

Remarks:
  This setting controls the billboard rotation type, you can deciding rotate the billboard's vertices around their facing direction or rotate the billboard's texture coordinates.

  The default settings is BBR_TEXCOORD.

Parameters:

  | rotationType | A member of the BillboardRotationType enum specifying the rotation type for all the billboards in this set.

BillboardRotationType Ogre::BillboardParticleRenderer::getBillboardRotationType | ( | void |  | ) | const

Sets billboard rotation type.

Returns:
  A member of the BillboardRotationType enum specifying the rotation type for all the billboards in this set.

void Ogre::BillboardParticleRenderer::setCommonDirection | ( | const Vector3 & | vec | ) |

Use this to specify the common direction given to billboards of type BBT_ORIENTED_COMMON.

Remarks:
  Use BBT_ORIENTED_COMMON when you want oriented billboards but you know they are always going to be oriented the same way (e.g. rain in calm weather). It is faster for the system to calculate the billboard vertices if they have a common direction.

Parameters:

  | vec | The direction for all billboards.

const Vector3& Ogre::BillboardParticleRenderer::getCommonDirection | ( | void |  | ) | const

Gets the common direction for all billboards (BBT_ORIENTED_COMMON).

void Ogre::BillboardParticleRenderer::setCommonUpVector | ( | const Vector3 & | vec | ) |

Use this to specify the common up-vector given to billboards of type BBT_PERPENDICULAR_SELF.

Remarks:
  Use BBT_PERPENDICULAR_SELF when you want oriented billboards perpendicular to their own direction vector and doesn't face to camera. In this case, we need an additional vector to determine the billboard X, Y axis. The generated X axis perpendicular to both the own direction and up-vector, the Y axis will coplanar with both own direction and up-vector, and perpendicular to own direction.

Parameters:

  | vec | The up-vector for all billboards.

const Vector3& Ogre::BillboardParticleRenderer::getCommonUpVector | ( | void |  | ) | const

Gets the common up-vector for all billboards (BBT_PERPENDICULAR_SELF).

void Ogre::BillboardParticleRenderer::setPointRenderingEnabled | ( | bool | enabled | ) |

Set whether or not the BillboardSet will use point rendering rather than manually generated quads.

Remarks:
  By default a billboardset is rendered by generating geometry for a textured quad in memory, taking into account the size and orientation settings, and uploading it to the video card. The alternative is to use hardware point rendering, which means that only one position needs to be sent per billboard rather than 4 and the hardware sorts out how this is rendered based on the render state.

  Using point rendering is faster than generating quads manually, but is more restrictive. The following restrictions apply:
  - Only the BBT_POINT type is supported
  - Size and appearance of each billboard is controlled by the material (Pass::setPointSize, Pass::setPointSizeAttenuation, Pass::setPointSpritesEnabled)
  - Per-billboard size is not supported (stems from the above)
  - Per-billboard rotation is not supported, this can only be controlled through texture unit rotation
  - Only BBO_CENTER origin is supported
  - Per-billboard texture coordinates are not supported

  You will almost certainly want to enable in your material pass both point attenuation and point sprites if you use this option.

Parameters:

  | enabled | True to enable point rendering, false otherwise

bool Ogre::BillboardParticleRenderer::isPointRenderingEnabled | ( | void |  | ) | const

Returns whether point rendering is enabled.

const String& Ogre::BillboardParticleRenderer::getType | ( | void |  | ) | const`[virtual]`

Gets the type of this renderer - must be implemented by subclasses.

Implements Ogre::ParticleSystemRenderer.

void Ogre::BillboardParticleRenderer::_updateRenderQueue | ( | RenderQueue * | queue,
|  | std::list< Particle * > & | currentParticles,
|  | bool | cullIndividually |
| ) |  |  | `[virtual]`

Delegated to by ParticleSystem::_updateRenderQueue.

Remarks:
  The subclass must update the render queue using whichever Renderable instance(s) it wishes.

Implements Ogre::ParticleSystemRenderer.

void Ogre::BillboardParticleRenderer::visitRenderables | ( | Renderable::Visitor * | visitor,
|  | bool | debugRenderables = `false` |
| ) |  |  | `[virtual]`

Required method to allow the renderer to communicate the Renderables it will be using to render the system to a visitor.

See also:
  MovableObject::visitRenderables

Implements Ogre::ParticleSystemRenderer.

void Ogre::BillboardParticleRenderer::_setMaterial | ( | MaterialPtr & | mat | ) | `[virtual]`

Sets the material this renderer must use; called by ParticleSystem.

Implements Ogre::ParticleSystemRenderer.

void Ogre::BillboardParticleRenderer::_notifyCurrentCamera | ( | Camera * | cam | ) | `[virtual]`

Delegated to by ParticleSystem::_notifyCurrentCamera.

Implements Ogre::ParticleSystemRenderer.

void Ogre::BillboardParticleRenderer::_notifyParticleRotated | ( | void |  | ) | `[virtual]`

Optional callback notified when particles are rotated.

Reimplemented from Ogre::ParticleSystemRenderer.

void Ogre::BillboardParticleRenderer::_notifyParticleResized | ( | void |  | ) | `[virtual]`

Optional callback notified when particles are resized individually.

Reimplemented from Ogre::ParticleSystemRenderer.

void Ogre::BillboardParticleRenderer::_notifyParticleQuota | ( | size_t | quota | ) | `[virtual]`

Tells the renderer that the particle quota has changed.

Implements Ogre::ParticleSystemRenderer.

void Ogre::BillboardParticleRenderer::_notifyAttached | ( | Node * | parent,
|  | bool | isTagPoint = `false` |
| ) |  |  | `[virtual]`

Delegated to by ParticleSystem::_notifyAttached.

Implements Ogre::ParticleSystemRenderer.

void Ogre::BillboardParticleRenderer::_notifyDefaultDimensions | ( | Real | width,
|  | Real | height |
| ) |  |  | `[virtual]`

Tells the renderer that the particle default size has changed.

Implements Ogre::ParticleSystemRenderer.

void Ogre::BillboardParticleRenderer::setRenderQueueGroup | ( | uint8 | queueID | ) | `[virtual]`

Sets which render queue group this renderer should target with it's output.

Implements Ogre::ParticleSystemRenderer.

void Ogre::BillboardParticleRenderer::setKeepParticlesInLocalSpace | ( | bool | keepLocal | ) | `[virtual]`

Setting carried over from ParticleSystem.

Implements Ogre::ParticleSystemRenderer.

SortMode Ogre::BillboardParticleRenderer::_getSortMode | ( | void |  | ) | const`[virtual]`

Gets the desired particles sort mode of this renderer.

Implements Ogre::ParticleSystemRenderer.

BillboardSet* Ogre::BillboardParticleRenderer::getBillboardSet | ( | void |  | ) | const

Access BillboardSet in use.

Definition at line 224 of file OgreBillboardParticleRenderer.h.

virtual void Ogre::ParticleSystemRenderer::_notifyParticleEmitted | ( | Particle * | particle | ) | `[virtual, inherited]`

Optional callback notified when particle emitted.

Definition at line 78 of file OgreParticleSystemRenderer.h.

virtual void Ogre::ParticleSystemRenderer::_notifyParticleExpired | ( | Particle * | particle | ) | `[virtual, inherited]`

Optional callback notified when particle expired.

Definition at line 80 of file OgreParticleSystemRenderer.h.

virtual void Ogre::ParticleSystemRenderer::_notifyParticleMoved | ( | std::list< Particle * > & | currentParticles | ) | `[virtual, inherited]`

Optional callback notified when particles moved.

Definition at line 82 of file OgreParticleSystemRenderer.h.

virtual void Ogre::ParticleSystemRenderer::_notifyParticleCleared | ( | std::list< Particle * > & | currentParticles | ) | `[virtual, inherited]`

Optional callback notified when particles cleared.

Definition at line 84 of file OgreParticleSystemRenderer.h.

virtual ParticleVisualData* Ogre::ParticleSystemRenderer::_createVisualData | ( | void |  | ) | `[virtual, inherited]`

Create a new ParticleVisualData instance for attachment to a particle.

Remarks:
  If this renderer needs additional data in each particle, then this should be held in an instance of a subclass of ParticleVisualData, and this method should be overridden to return a new instance of it. The default behaviour is to return null.

Definition at line 92 of file OgreParticleSystemRenderer.h.

virtual void Ogre::ParticleSystemRenderer::_destroyVisualData | ( | ParticleVisualData * | vis | ) | `[virtual, inherited]`

Destroy a ParticleVisualData instance.

Remarks:
  If this renderer needs additional data in each particle, then this should be held in an instance of a subclass of ParticleVisualData, and this method should be overridden to destroy an instance of it. The default behaviour is to do nothing.

Definition at line 100 of file OgreParticleSystemRenderer.h.

bool Ogre::StringInterface::createParamDictionary | ( | const String & | className | ) | `[protected, inherited]`

Internal method for creating a parameter dictionary for the class, if it does not already exist.

Remarks:
  This method will check to see if a parameter dictionary exist for this class yet, and if not will create one. NB you must supply the name of the class (RTTI is not used or performance).

Parameters:

  | className | the name of the class using the dictionary

Returns:
  true if a new dictionary was created, false if it was already there

Definition at line 176 of file OgreStringInterface.h.

ParamDictionary* Ogre::StringInterface::getParamDictionary | ( | void |  | ) | `[inherited]`

Retrieves the parameter dictionary for this class.

Remarks:
  Only valid to call this after createParamDictionary.

Returns:
  Pointer to ParamDictionary shared by all instances of this class which you can add parameters to, retrieve parameters etc.

Definition at line 200 of file OgreStringInterface.h.

const ParamDictionary* Ogre::StringInterface::getParamDictionary | ( | void |  | ) | const`[inherited]`

Definition at line 213 of file OgreStringInterface.h.

const ParameterList& Ogre::StringInterface::getParameters | ( | void |  | ) | const`[inherited]`

Retrieves a list of parameters valid for this object.

Returns:
  A reference to a static list of ParameterDef objects.

virtual bool Ogre::StringInterface::setParameter | ( | const String & | name,
|  | const String & | value |
| ) |  |  | `[virtual, inherited]`

Generic parameter setting method.

Remarks:
  Call this method with the name of a parameter and a string version of the value to set. The implementor will convert the string to a native type internally. If in doubt, check the parameter definition in the list returned from StringInterface::getParameters.

Parameters:

  | name | The name of the parameter to set
  | value | String value. Must be in the right format for the type specified in the parameter definition. See the StringConverter class for more information.

Returns:
  true if set was successful, false otherwise (NB no exceptions thrown - tolerant method)

Referenced by Ogre::StringInterface::copyParametersTo().

virtual void Ogre::StringInterface::setParameterList | ( | const NameValuePairList & | paramList | ) | `[virtual, inherited]`

Generic multiple parameter setting method.

Remarks:
  Call this method with a list of name / value pairs to set. The implementor will convert the string to a native type internally. If in doubt, check the parameter definition in the list returned from StringInterface::getParameters.

Parameters:

  | paramList | Name/value pair list

virtual String Ogre::StringInterface::getParameter | ( | const String & | name | ) | const`[virtual, inherited]`

Generic parameter retrieval method.

Remarks:
  Call this method with the name of a parameter to retrieve a string-format value of the parameter in question. If in doubt, check the parameter definition in the list returned from getParameters for the type of this parameter. If you like you can use StringConverter to convert this string back into a native type.

Parameters:

  | name | The name of the parameter to get

Returns:
  String value of parameter, blank if not found

Definition at line 269 of file OgreStringInterface.h.

References Ogre::ParamCommand::doGet(), and Ogre::ParamDictionary::getParamCommand().

virtual void Ogre::StringInterface::copyParametersTo | ( | StringInterface * | dest | ) | const`[virtual, inherited]`

Method for copying this object's parameters to another object.

Remarks:
  This method takes the values of all the object's parameters and tries to set the same values on the destination object. This provides a completely type independent way to copy parameters to other objects. Note that because of the String manipulation involved, this should not be regarded as an efficient process and should be saved for times outside of the rendering loop.

  Any unrecognised parameters will be ignored as with setParameter method.

Parameters:

  | dest | Pointer to object to have it's parameters set the same as this object.

Definition at line 300 of file OgreStringInterface.h.

References Ogre::ParamDictionary::mParamDefs, and Ogre::StringInterface::setParameter().

static void Ogre::StringInterface::cleanupDictionary | ( |  | ) | `[static, inherited]`

Cleans up the static 'msDictionary' required to reset Ogre, otherwise the containers are left with invalid pointers, which will lead to a crash as soon as one of the ResourceManager implementers (e.g.

MaterialManager) initializes.

template<class Alloc>

void* Ogre::AllocatedObject< Alloc >::operator new | ( | size_t | sz,
|  | const char * | file,
|  | int | line,
|  | const char * | func |
| ) |  |  | `[inherited]`

operator new, with debug line info

Definition at line 62 of file OgreMemoryAllocatedObject.h.

template<class Alloc>

void* Ogre::AllocatedObject< Alloc >::operator new | ( | size_t | sz | ) | `[inherited]`

Definition at line 67 of file OgreMemoryAllocatedObject.h.

template<class Alloc>

void* Ogre::AllocatedObject< Alloc >::operator new | ( | size_t | sz,
|  | void * | ptr |
| ) |  |  | `[inherited]`

placement operator new

Definition at line 73 of file OgreMemoryAllocatedObject.h.

template<class Alloc>

void* Ogre::AllocatedObject< Alloc >::operator new[] | ( | size_t | sz,
|  | const char * | file,
|  | int | line,
|  | const char * | func |
| ) |  |  | `[inherited]`

array operator new, with debug line info

Definition at line 79 of file OgreMemoryAllocatedObject.h.

template<class Alloc>

void* Ogre::AllocatedObject< Alloc >::operator new[] | ( | size_t | sz | ) | `[inherited]`

Definition at line 84 of file OgreMemoryAllocatedObject.h.

template<class Alloc>

void Ogre::AllocatedObject< Alloc >::operator delete | ( | void * | ptr | ) | `[inherited]`

Definition at line 89 of file OgreMemoryAllocatedObject.h.

template<class Alloc>

void Ogre::AllocatedObject< Alloc >::operator delete | ( | void * | ptr,
|  | void * |  |
| ) |  |  | `[inherited]`

Definition at line 95 of file OgreMemoryAllocatedObject.h.

template<class Alloc>

void Ogre::AllocatedObject< Alloc >::operator delete | ( | void * | ptr,
|  | const char * | ,
|  | int | ,
|  | const char * |  |
| ) |  |  | `[inherited]`

Definition at line 101 of file OgreMemoryAllocatedObject.h.

template<class Alloc>

void Ogre::AllocatedObject< Alloc >::operator delete[] | ( | void * | ptr | ) | `[inherited]`

Definition at line 106 of file OgreMemoryAllocatedObject.h.

template<class Alloc>

void Ogre::AllocatedObject< Alloc >::operator delete[] | ( | void * | ptr,
|  | const char * | ,
|  | int | ,
|  | const char * |  |
| ) |  |  | `[inherited]`

Definition at line 112 of file OgreMemoryAllocatedObject.h.

## Member Data Documentation

BillboardSet* Ogre::BillboardParticleRenderer::mBillboardSet`[protected]`

The billboard set that's doing the rendering.

Definition at line 49 of file OgreBillboardParticleRenderer.h.

CmdBillboardType Ogre::BillboardParticleRenderer::msBillboardTypeCmd`[static, protected]`

Definition at line 227 of file OgreBillboardParticleRenderer.h.

CmdBillboardOrigin Ogre::BillboardParticleRenderer::msBillboardOriginCmd`[static, protected]`

Definition at line 228 of file OgreBillboardParticleRenderer.h.

CmdBillboardRotationType Ogre::BillboardParticleRenderer::msBillboardRotationTypeCmd`[static, protected]`

Definition at line 229 of file OgreBillboardParticleRenderer.h.

CmdCommonDirection Ogre::BillboardParticleRenderer::msCommonDirectionCmd`[static, protected]`

Definition at line 230 of file OgreBillboardParticleRenderer.h.

CmdCommonUpVector Ogre::BillboardParticleRenderer::msCommonUpVectorCmd`[static, protected]`

Definition at line 231 of file OgreBillboardParticleRenderer.h.

CmdPointRendering Ogre::BillboardParticleRenderer::msPointRenderingCmd`[static, protected]`

Definition at line 232 of file OgreBillboardParticleRenderer.h.

CmdAccurateFacing Ogre::BillboardParticleRenderer::msAccurateFacingCmd`[static, protected]`

Definition at line 233 of file OgreBillboardParticleRenderer.h.

ParamDictionaryMap Ogre::StringInterface::msDictionary`[static, protected, inherited]`

Dictionary of parameters.

Definition at line 161 of file OgreStringInterface.h.

String Ogre::StringInterface::mParamDictName`[protected, inherited]`

Class name for this instance to be used as a lookup (must be initialised by subclasses).

Definition at line 164 of file OgreStringInterface.h.

The documentation for this class was generated from the following file:

- OgreBillboardParticleRenderer.h

Copyright © 2008 Torus Knot Software Ltd
This work is licensed under a Creative Commons Attribution-ShareAlike 2.5 License.
Last modified Sun Jul 26 11:32:48 2009